library EDialogs;

{EDialogs DLL for mIRC / written by Kermit / Contact me at tal@112.co.il / Enjoy}

uses
  windows,
  sysutils,
  dialogs,
  extdlgs,
  JPEG;

type
  TLoadInfo = packed record
    mVersion : DWORD;
    mHwnd    : HWND;
    mKeep    : Boolean;
  end;
    PLoadInfo = ^TLoadInfo;

procedure LoadDll(LoadInfo: PLoadInfo); stdcall; export;
begin
  LoadInfo.mKeep := false;
end;

procedure UnloadDll(mTimeOut: integer); stdcall; export;
begin

end;

function EDlg( mWnd: hWnd; aWnd: hWnd; Data: PChar; Parms: PChar;
Show: Boolean; NoPause: Boolean ): Integer; export; stdcall;
var
  O: TCommonDialog;
  s: string;
  I: integer;
begin
  {What Dialog?}
  if lowercase(copy(data,1,1)) = 's' then
    O:=TSaveDialog.Create(nil)
  else
  if lowercase(copy(data,1,1)) = 'l' then
    O:=TOpenPictureDialog.Create(nil)
  else
  if lowercase(copy(data,1,1)) = 'p' then
    O:=TSavePictureDialog.Create(nil)
  else
    O:=TOpenDialog.Create(nil);
  {Dialog's parameters}
  with O as TOpenDialog do
  begin
    Filter:=copy(data, pos('|',data)+1,length(data)-pos('|',data)-1);
    FilterIndex:=1;
    InitialDir:=copy(data, 2, pos('>',data)-2);
    Title:=copy(data, pos('>',data)+1, pos('|',data)-pos('>',data)-2);
    if (lowercase(copy(data,1,1)) <> 's') and (lowercase(copy(data,1,1)) <> 'p') then
      if lowercase(copy(data,length(data),1)) = 'y' then Options:=options + [ofAllowMultiSelect];
    Options:=Options+[ofFileMustExist,ofPathMustExist,ofCreatePrompt,ofOverwritePrompt];
  if not Execute then {Execute the dialog if canceled then halt process}
    result:=0
  else
  begin
  {What returns to mIRC}
    if files.count > 1 then
    begin
      S:=extractfiledir(files.Strings[0])+'|';
      for I:=0 to files.Count - 1 do
      begin
        if length(S+extractfilename(files.Strings[I])+'|') > 933 then
          break;
        S:=S+extractfilename(files.Strings[I])+'|';
      end;
      strcopy(data, pchar(s));
    end
    else
      strcopy(data, pchar(copy(files.text, 1, length(files.text)-2)));
    result:=3;
  end;
  free;{free the memory used by the dialog}
  end;
end;

function About( mWnd: hWnd; aWnd: hWnd; Data: PChar; Parms: PChar;
Show: Boolean; NoPause: Boolean ): Integer; export; stdcall;
begin
  strcopy(data, 'EDialogs DLL / coded by Kermit. Contact me at tal@112.co.il.');
  result:=3;
end;

exports
  LoadDll,
  UnloadDll,
  EDlg,
  About;

end.



